2007-05-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/body_sensor.cpp:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/audio_sensor.cpp:
	* rcsc/trainer/trainer_agent.cpp:
	* rcsc/coach/global_visual_sensor.cpp:
	* rcsc/coach/coach_agent.cpp:
	- Specified a string buffer size in all sscanf.

	* rcsc/trainer/trainer_agent.cpp:
	- Fixed a segmentation fault caused by the too small buffer size.

2007-05-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- Updated a micro version.

	* rcsc/trainer/trainer_command.cpp (toStr):
	- Added a missing parenthesis.

2007-04-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/Makefile.am (librcsc_agent_la_LDFLAGS):
	* rcsc/geom/Makefile.am (librcsc_geominclude_HEADERS):
	- updated libtool version.

	* configure.ac:
	- commented out AC_TYPE_INT32_T

	* rcsc/trainer/coach_agent.cpp:
	* rcsc/trainer/coach_agent.h:
	* rcsc/trainer/trainer_agent.cpp:
	* rcsc/trainer/trainer_agent.h:
	- fixed finalization process.

	* rcsc/player/coach_agent.cpp:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/trainer_agent.cpp:
	- added null pointer check for M_client.

	* rcsc/common/soccer_agent.cpp:
	* rcsc/common/soccer_agent.h:
	* rcsc/player/coach_agent.h:
	* rcsc/player/coach_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/trainer_agent.h:
	* rcsc/player/trainer_agent.cpp:
	- moved a BasicClient pointer argument from SoccerAgent
	constructor to SoccerAgent::init().

	* example/Makefile.am:
	* src/Makefile.am:
	- fixed LDFLAGS pathes.

	* rcsc/rcg/util.cpp:
	* rcsc/rcg/util.h:
	- replaced boost::int??_t by Int??

2007-04-05  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_dribble2006.cpp:
	* rcsc/action/body_dribble2006.h:
	- copied from old code.

	* rcsc/action/body_dribble.cpp:
	* rcsc/action/body_dribble.h:
	* rcsc/action/body_intercept.cpp:
	* rcsc/action/body_intercept.h:
	* rcsc/action/body_shoot.cpp:
	* rcsc/action/body_shoot.h:
	* rcsc/action/shoot_table.cpp:
	* rcsc/action/shoot_table.h:
	- ported from helios.

	* rcsc/rcg/types.h:
	- added typedef of Int16 and Int32.
	- replaced boost::int??_t by Int??

	* rcsc/action/Makefile.am:
	* rcsc/coach/Makefile.am:
	* rcsc/formation/Makefile.am:
	* rcsc/player/Makefile.am:
	* rcsc/trainer/Makefile.am:
	- added -I(top_srcdir) to AM_CPPFLAGS

	* configure.ac:
	* config/ax_boost_base.m4:
	- added AX_BOOST_BASE for boost checking.

2007-03-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp (localizePlayers):
	- increased the opponent size limitation to 15.

2007-03-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/neck_scan_field.cpp (calcAngle):
	- added a face angle limitation rule.

2007-03-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/neck_turn_to_player_or_scan.cpp:
	* rcsc/action/neck_turn_to_player_or_scan.h:
	- added new neck action Neck_TurnToPlayerOrScan.

	* rcsc/action/basic_actions.cpp:
	- reimplemented Neck_TurnToBall::execute(). Now, player can scan
	field and look the ball at the same time.

	* rcsc/player/world_model.cpp (updateOffsideLine):
	- tuned rule to consider about a virtual goalie

	* rcsc/player/self_intercept.cpp (getOneStepBestTrapPower):
	- tuned 1 step interception trap point.

2007-03-07  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/vector_2d.h:
	- added missing const modifier.

	* rcsc/player/world_model.cpp (localizeBall):
	- tuned collision check.

2007-03-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/action_effector.cpp:
	* rcsc/player/action_effector.h:
	- added queuedNextBallKickable() for the convinience.

2007-03-05  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_kick_two_step.cpp (simulate_two_kick):
	- changed a best kick selection policy.

	* rcsc/player/player_object.h:
	- renamed PtrConfCmp to PtrCountCmp
	- changed the policy to compar the accuracy count for goalie in
	PtrCountCmp. goalie is always handled as the minimum counted
	player.

	* rcsc/action/neck_scan_field.cpp:
	- expanded the bouding aria

2007-03-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/neck_scan_field.cpp:
	- tuned a selection rule.

	* rcsc/player/view_mode.cpp:
	* rcsc/player/view_mode.h:
	- renamed ViewWidth::getWidth() to width();

	* rcsc/player/world_model.cpp (localizePlayers):
	- changed player matching order. Now, opponent, unknown opponent,
	teammate, unknown teammate and unknown player.
	(updateDirCount):
	- reimplemented. Now, dir buffer is strictry considered.

2007-03-02  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- changed the update policy for an unknown player. Now, if several
	candidate players exist and they include teammate, opponent and
	unknown player, teammates is always ignored and opponent or
	unknown player is always selected. And also, if an unknown player
	is contained within the view cone and its distance is less than
	TEAM_FAR_LENGTH, that player is erased from the memory.
	- reimplemented dirRangeCount()

2007-03-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_kick_two_step.cpp (simulate_two_kick):
	- tuned sub target distance buffer.

2007-02-28  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp:
	- moved updateCollision() from updateAfterSense() to
	updateJustBeforeDecision()

	* rcsc/action/body_kick_two_step.cpp:
	- disabled an enforce kick flag for the two step simulation.

2007-02-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp:
	- added the offside line update operation using a heard info.
	- added the heuristic rule to consider the opponent goalie.
	- added a strict goalie estimation when the heard info is used.

	* rcsc/player/Makefile.am:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/world_model.cpp:
	* rcsc/player/world_model.h:
	- removed ActionType

	* rcsc/player/world_model.cpp:
	- changed a player matching policy.
	- set the limitation to the maximum dir count value.

	* rcsc/action/body_hold_ball.cpp:
	- tuned a keep distance buffer.

	* rcsc/action/basic_actions.cpp:
	* rcsc/action/neck_turn_to_ball_or_scan.cpp:
	- added the strict check of the next ball state.

	* rcsc/player/world_model.cpp (localizeBall):
	- removed ball velocity update which uses a heard position.

2007-02-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_kick_two_step.cpp (simulate_two_kick):
	- tuned distance of the kick subtarget.

	* rcsc/player/self_object.cpp (getSafetyDashPower):
	- fixed defect that the retuned power may be larger than input
	value.

	* rcsc/common/player_type.cpp:
	* rcsc/common/player_type.h:
	- added maxDashCyclesWith()
	- added consumedStaminaAfterNrDash()

2007-02-22  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/intercept_table.cpp:
	* rcsc/player/intercept_table.h:
	* rcsc/player/world_model.cpp:
	* rcsc/player/world_model.h:
	- implemented interception info update using communication.

	* rcsc/player/player_agent.cpp (analyzeHearPlayer):
	* rcsc/player/audio_sensor.cpp:
	* rcsc/player/audio_sensor.h:
	- supported multiple info in one message.

	* rcsc/player/audio_codec.cpp:
	* rcsc/player/audio_codec.h:
	- Now, the return value type of all encoding method is std::string
	or char.

2007-02-21  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/self_intercept.cpp (predictNoDash):
	- tuned no turn interception threshold.

2007-02-20  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/coach/global_visual_sensor.cpp:
	* rcsc/coach/global_world_model.cpp:
	* rcsc/trainer/trainer_agent.cpp:
	- added team name update procedure using (see_global) and/or
	(ok team_names) message.

2007-02-14  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/intention_dribble.cpp:
	- tuned oppnent check.

	* rcsc/action/body_shoot.cpp (execute):
	- added one step kick rule.
	- fixed ball first speed in 2 step kick.

2007-02-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/neck_turn_to_goalie_or_scan.cpp:
	* rcsc/action/neck_turn_to_goalie_or_scan.h:
	- added M_count_thr variable.

2007-02-05  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/player_intercept.cpp:
	- changed accuracy count handling policy in the other player
	prediction.

	* rcsc/action/body_pass.cpp:
	- fixed defects in the through pass generation.
	- tuned through pass verification parameters.

	* rcsc/action/neck_turn_to_low_conf_teammate.cpp (execute):
	- added check of the ghost flag.

2007-02-04  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_pass.cpp:
	- tuned pass parameters.

	* rcsc/geom/rect_2d.h:
	- added static method, from_center() with 4 arguments for the
	convinience.

	* rcsc/common/player_type.cpp (cyclesToReachDistance):
	- added a semi strict estimation using a dash distance table.

	* rcsc/action/body_pass.cpp (create_through_pass):
	- tuned through pass end speed.

2007-02-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/intention_dribble.cpp (doDash):
	- fixed angle value in next kickable check.

	* rcsc/player/self_intercept.cpp (canReachAfterDash):
	- tuned interception buffer

	* rcsc/player/ball_object.cpp (updateByHeardInfo):
	- added velocity only update operation.

2007-02-02  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp:
	* rcsc/player/world_model.h:
	- added new variables, M_last_action_type and
	M_time_last_action_type. accessor methods are also added.

	* rcsc/player/soccer_action.h:
	- declared enum ActionType. but not used yet.

	* rcsc/player/world_model.h:
	- added new template methods counteTeammateIn() and
	counteOpponentIn()

	* rcsc/player/player_object.cpp:
	* rcsc/player/player_object.h:
	- added a new property, M_ghost. when the ghost object is
	detected, this property is set true.

2007-02-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.h:
	- added new interfaces getDistTeammateNearestToSelf(),
	getDistOpponentNearestToSelf(), getDistOpponentNearestToBall() and
	getDistOpponentNearestToBall()

	* rcsc/action/body_kick_one_step.cpp (get_max_possible_vel):
	- fixed a ball reachable area check.

	* rcsc/action/body_intercept.cpp:
	* rcsc/action/body_intercept.h:
	- added a new member variable, M_face_point.

2007-01-31  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_kick_two_step.cpp (simulate_two_kick):
	- tuned subtarget distance.

	* rcsc/geom/circle_2d.cpp (intersection):
	- fixed invalid constant variable of the intersection line.

2007-01-30  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/types.h:
	* rcsc/rcg/util.cpp:
	* rcsc/rcg/util.h:
	- changed type of all short and long variables to boost::int16_t
	and boost::int32_t respectively.

	* rcsc/geom/circle_2d.cpp:
	* rcsc/geom/circle_2d.h:
	- added new method to calculate the intersection with other
	circle.

2007-01-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp (checkTeamPlayer):
	- fixed bug of the uniform number check.

2007-01-25  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/audio_codec.cpp:
	* rcsc/player/audio_codec.h:
	* rcsc/player/audio_sensor.cpp:
	* rcsc/player/audio_sensor.h:
	- renamed audio encode/decode method.
	- cleaned up the code.

	* rcsc/geom/line_2d.cpp:
	* rcsc/geom/vector_2d.cpp:
	- Now, the value of Vector2D::ERROR_VALUE is std::numelic_limits<
	double >::max()

2007-01-23  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/audio_sensor.cpp (parseGoalieInfo):
	- fixed bug that goalie number is not set.

	* rcsc/param/param_map.cpp:
	* rcsc/param/param_map.h:
	- added with_value argument to ParamMap::printHelp().

	* rcsc/player/fullstate_sensor.cpp:
	* rcsc/player/fullstate_sensor.h:
	* rcsc/player/player_agent.cpp:
	- fixed bugs about fullstate info for the right side team.

2007-01-22  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/world_model.cpp:
	* rcsc/player/world_model.h:
	- renamed getTeammateHeteroID() to teamamteHeteroID()
	- renamed getOpponentHeteroID() to opponentHeteroID()
	- added teammatePlayerType() and opponentPlayerType().

	* rcsc/action/body_intercept.cpp:
	- tuned opponent buffer.

2007-01-15  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation_ngnet.cpp:
	* rcsc/formation/formation_ngnet.h:
	* rcsc/formation/formation_rbf.cpp:
	* rcsc/formation/formation_rbf.h:
	- added new formation models using a neural network library.

	* rcsc/ann/bpn1.h:
	- moved from rcsc/

	* rcsc/ann/Makefile.am:
	* rcsc/ann/ngnet.cpp:
	* rcsc/ann/ngnet.h:
	* rcsc/ann/rbf.cpp:
	* rcsc/ann/rbf.h:
	- added an artificial neural network library.

2006-12-19  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* bootstrap:
	- Now, bootstrap script has the compatibility with MacOSX.

	* rcsc/Makefile.am (librcsc_agent_la_LIBADD):
	- removed librcsc_param.la from the list

	* configure.ac:
	- added BOOST_CPPFLAGS to CPPFLAGS
	- added BOOST_LDFLAGS to LDFLAGS

	* rcsc/common/server_param.h:
	* rcsc/common/server_param.cpp:
	- added DEFAULT_PENALTY_CIRCLE_R.

2006-12-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	* config/ax_boost.m4:
	- added m4 macro for boost.

2006-12-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/Makefile.am:
	- fixed duplicated header files.

2006-12-07  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/bpn1.h:
	- fixed error calculation procedure.

2006-12-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/delaunay_triangulation.cpp (createInitialTriangle):
	- fixed invalid variable reference.

	* rcsc/bpn1.h:
	- added inverse functions and differencial functions for x.
	- renamed diff() to diffAtY()

	* rcsc/geom/rect_2d.h:
	- renamed make_with_center() to from_center().
	- renamed make_with_points() to from_corner().

2006-11-29  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation_factory.h:
	* rcsc/formation/formation_factory.cpp:
	- added covinience factory method, make_formation().

2006-11-28  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation_dt.h:
	- added get method to refere the triangulation object.

2006-11-13  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/player_config.h:
	* rcsc/player/player_config.cpp:
	- added M_log_ext option to configure the extention of the debug
	log file.

	* rcsc/player/debug_client.h:
	* rcsc/player/debug_client.cpp:
	- output file is replaced with Logger.
	- removed freeform message.

	* rcsc/player/logger.h:
	* rcsc/player/logger.cpp:
	- added print() method to put the message directry.

	* rcsc/player/player_agent.h:
	- removed getConfig()
	- removed initTeam()

	* configure.ac:
	- added check of arpa/inet.h and inet_addr().
	- addec AC_TYPE_INT32_T

	* rcsc/net/udp_socket.cpp:
	- added support of inet_addr.
	- added strict error check

	* configure.ac:
	* rcsc/Makefile.am:
	* rcsc/geom/Makefile.am:
	* rcsc/gz/Makefile.am:
	* rcsc/param/Makefile.am:
	* rcsc/rcg/Makefile.am:
	* src/Makefile.am:
	- fixed installed header files dependency.
	- split librcsc_param from librcsc_agent.
	- removed redundunt configure options, --enable-geom, --enable-gz
	and --enable-rcg.

	* rcsc/action.h:
	* rcsc/coach.h:
	* rcsc/net.h
	* rcsc/param.h
	* rcsc/player.h
	* rcsc/trainer.h
	- removed.redundant header files.

	* rcsc/player/localization.h:
	* rcsc/player/localization.cpp:
	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- cleaned up the member function arguments.

	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- removed M_unknown_teammates and M_unknown_opponents.

	* rcsc/types.h:
	- added enum Unum.

	* rcsc/formation/formation_static.h:
	* rcsc/formation/formation_static.cpp:
	- added new formation type, FormationStatic.

	* rcsc/param/player_param.h:
	* rcsc/param/player_param.h:
	* rcsc/param/player_type.h:
	* rcsc/param/player_type.h:
	* rcsc/param/server_param.h:
	* rcsc/param/server_param.h:
	- moved into 'common'.

	* rcsc/client/:
	* rcsc/common/:
	- renamed 'client directory to 'common'

2006-11-12  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/client/basic_client.h:
	* rcsc/client/basic_client.cpp:
	- supported compression message transportation. But compression
	communication does not work because rcssserver-10.0.7 has bugs int
	gzstream filter.

	* rcsc/gz/gzcompressor.h:
	* rcsc/gz/gzcompressor.cpp:
	- added gzip compressor/decompressor.
	- reimplemented by Pimpl ideom.

2006-11-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/holder.cpp:
	- Now, log version is set when dispinfo is added.

2006-11-10  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/gz/gzfilterstream.h:
	* rcsc/gz/gzfilterstream.cpp:
	- fixed defect about compression level. Now, default compression
	level is 6. -1 is never used as a default compression level.

	* rcsc/coach/coach_agent.h:
	* rcsc/coach/coach_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/trainer_agent.h:
	* rcsc/player/trainer_agent.cpp:
	- renamed doAction() to actionImpl().
	- renamed doCommunication() to communicationImpl().

	* rcsc/rcg/factory.h:
	* rcsc/rcg/factory.cpp:
	- added make_serializer(int).

	* rcsc/rcg/serializer.h:
	* rcsc/rcg/serializer.cpp:
	* rcsc/rcg/serializer_v1.h:
	* rcsc/rcg/serializer_v1.cpp:
	* rcsc/rcg/serializer_v2.h:
	* rcsc/rcg/serializer_v2.cpp:
	* rcsc/rcg/serializer_v3.h:
	* rcsc/rcg/serializer_v3.cpp:
	- added and implemented.

	* rcsc/coach/coach_agent.h:
	* rcsc/coach/coach_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/trainer/trainer_agent.h:
	* rcsc/trainer/trainer_agent.cpp:
	- split client features.

2006-11-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/util.h:
	* rcsc/rcg/util.cpp:
	- all definitions have moved into .cpp file.

2006-11-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- added libz valiable to check the presence of libz and the
	usability of librcsc_gz.

	* rcsc/client/soccer_agent.h:
	* rcsc/client/soccer_agent.cpp:
	- default constructo became private.
	- renamed doInit() to initImpl()

	* rcsc/client/basic_client.h:
	* rcsc/client/basic_client.cpp:
	- renamed recvBuf() to message()
	- removed member variable, M_timeout_count and
	M_waited_msec. These variable became the local variable in run().

2006-11-07  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/util.h:
	- added some utility methods to convert the local value to the
	network byte order value.

	* rcsc/param/player_type.h:
	* rcsc/param/player_type.cpp:
	* rcsc/param/server_param.:
	* rcsc/param/server_param.cpp:
	- added convertTo() to convert to the monitor protocol data
	format.

	* rcsc/client/basic_client.h:
	* rcsc/client/basic_client.cpp:
	- started to split client implimentation from soccer agent.

2006-11-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	- changed argument order to register the parameter pointer, name
	and description..
	- added vector as a parameter container. This is because to keep
	the parameter order in help message.
	- changed a help message format.

	* rcsc/param/cmd_line_parser.h:
	* rcsc/param/cmd_line_parser.cpp:
	- changed parsing policy. all successfully analyzed option name
	and its value are removed from memory. and positional options are
	separately analyzed.
	- added new status check method, failed().
	- renamed accessor method for positional option to
	positionalOptions().

2006-11-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- replaced all AC_CHECK_HEADER with AC_CHECK_HEADERS
	- set version number 1.2.0

2006-10-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/shoot_table.h:
	* rcsc/action/shoot_table.cpp:
	- added ShootTable class. search routins in Body_Shoot are moved
	to ShootTable.

	* rcsc/geom/matrix_2d.h:
	- renamed create_translation() to make_translation()
	- renamed create_scaling() to make_scaling()
	- renamed create_rotation() to make_rotation()

	* rcsc/geom/rect_2d.h:
	- renamed create_with_center() to make_with_center()
	- renamed create_with_points() to make_with_points()

2006-10-20  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_dribble.cpp:
	- tuned dribble avoidance search region.

2006-10-19  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* src/scheduler.cpp:
	- added '--help' and '-h' as a command line option.

2006-10-17  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/body_intercept.cpp:
	- tuned smart interception rules, especially for attacker.

	* rcsc/player/audio_codec.h:
	* rcsc/player/audio_codec.cpp:
	* rcsc/player/audio_sensor.h:
	* rcsc/player/audio_sensor.cpp:
	- encodePosToStr7() and decodeStr7ToPos() are moved from
	AudioSensor to AudioCodec.
	- TODO: need to reimplement all codec.

	* rcsc/player/audio_codec.h:
	* rcsc/player/audio_codec.cpp:
	- added static member method, unum2hex() and hex2unum().

	* rcsc/player/audio_sensor.h:
	* rcsc/player/audio_sensor.cpp:
	- implemented intercept info message builder/analyzer.
	- TODO: need to reimplement the communication model because the
	current implementation is too bad.
	- implemented hey pass info message builder/analyzer.

2006-10-16  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/game_mode.h:
	- renamed getPlayMode() to getServerPlayMode().

	* rcsc/geom/triangle_2d.h:
	- renamed getGravityCenter() to getCentroid().

	* rcsc/player/world_model.h:
	- renamed getSeeUpdateTime() to seeTime().

	* rcsc/*:
	- changed many things.
	- renamed allmost all simple getter methods. 'get' is removed.
	- fixed include order and include dependency.

2006-10-15  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/coach_agent.h:
	* rcsc/player/coach_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/trainer_agent.h:
	* rcsc/player/trainer_agent.cpp:
	- changed the policiy of a command line option operation. Now,
	only if "help" is given as a command line option, doInit() returns
	false. The concrete agent classes are responsible for the check of
	option error and the decision about the end of application.

	* rcsc/client/basic_client.h:
	* rcsc/client/basic_client.cpp:
	- doInit(int,char**) is changed to doInit(CmdLIneparser&).
	- The definition of init() is moved to the source file.

	* rcsc/param/cmd_line_parser.h:
	* rcsc/param/cmd_line_parser.cpp:
	- merged from librcsc-1.1.x and clened up the code.

2006-10-10  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation.h:
	* rcsc/formation/formation.cpp:
	* rcsc/formation/formation_bpn.h:
	* rcsc/formation/formation_bpn.cpp:
	* rcsc/formation/formation_dt.h:
	* rcsc/formation/formation_dt.cpp:
	* rcsc/formation/formation_sbsp.h:
	* rcsc/formation/formation_sbsp.cpp:
	* rcsc/formation/formation_uva.h:
	* rcsc/formation/formation_uva.cpp:
	- fixed copyright message.

2006-10-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/client/basic_client.h:
	* rcsc/coach/coach_agent.h:
	* rcsc/coach/coach_agent.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/trainer/trainer_agent.h:
	* rcsc/trainer/trainer_agent.cpp:
	- added new argument additional_param_map to doInit() to handle
	additional command line options from derived classes.

	* rcsc/formation/formation_uva.cpp (getPosition):
	- added static y percentage value 0.75.
	(readRoles):
	- fixed incorrect argument order in RoleParam constructor.

	* rcsc/formation/formation_bpn.h:
	* rcsc/formation/formation_bpn.cpp:
	* rcsc/formation/formation_dt.h:
	* rcsc/formation/formation_dt.cpp:
	* rcsc/formation/formation_sbsp.h:
	* rcsc/formation/formation_sbsp.cpp:
	- cleaned up the code.

2006-10-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation.h:
	* rcsc/formation/formation.cpp:
	- added readName() method to share the formation type parsing
	operation.

2006-10-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	* rcsc/Makefile.am:
	* rcsc/geom/Makefile.am:
	* rcsc/gz/Makefile.am:
	* rcsc/rcg/Makefile.am:
	- split librcsc to librcsc_geom, librcsc_gz, librcsc_rcg and
	librcsc_agent

	* rcsc/geom/line_2d.h:
	* rcsc/geom/line_2d.cpp:
	* rcsc/geom/ray_2d.h:
	* rcsc/geom/ray_2d.cpp:
	* rcsc/geom/segment_2d.h:
	* rcsc/geom/segment_2d.cpp:
	- changed return value type of all intersection()

	* rcsc/geom/vector_2d.h:
	- added type conversion operator, bool().
	- added new static const member variable, INVALIDATED as an
	invalidated value vector.
	- removed incomprehensible constructors and related enum
	declarationss.

	* rcsc/geom/rect_2d.h:
	- added new static factory methods, create_with_center() and
	create_with_points().
	- added new interfaces, setCenter().

2006-10-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/formation/formation.h:
	* rcsc/formation/formation.cpp:
	* rcsc/formation/formation_bpn.h:
	* rcsc/formation/formation_bpn.cpp:
	* rcsc/formation/formation_sbsp.h:
	* rcsc/formation/formation_sbsp.cpp:
	* rcsc/formation/formation_dt.h:
	* rcsc/formation/formation_dt.cpp:
	- moved from soccerwindow2.
	- renamed FormationDelaunay to FormationDT.
	- *important* renamed method name of the FormationDT, from
	"Delaunay" to "DelaunayTriangulation".

	* configure.ac:
	* rcsc/formation/Makefile.am:
	- added new directory.

	* rcsc/bpn1.h:
	- added missiing include <cmath>

2006-10-02  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/line_2d.h:
	- renamed getA(), getB() and getC() to a(), b(), c()

	* rcsc/geom/segment_2d.h:
	- fixed defect of contains(). In order to solve the computational
	error problem added epsilon buffer.

2006-10-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/Makefile.am (librcsc_la_LDFLAGS):
	- updated libtool library version from 2:1:2 to 3:0:0

	* rcsc/coach/Makefile.am:
	- removed cycle_data.{h,cpp}

	* rcsc/coach/global_visual_sensor.h:
	* rcsc/coach/global_visual_sensor.cpp:
	* rcsc/coach/global_world_model.h:
	* rcsc/coach/global_world_model.cpp:
	- removed CycleData.
	- reimplemented with new classes.

	* rcsc/coach/global_object.h:
	* rcsc/coach/global_object.cpp:
	- added new files.
	- added new classes, GlobalBallObject and GlobalPlayerObject.

	* rcsc/player/audio_sensor.cpp (encodePass, encodePosToStr7)
	(encodeOffsideLineX, encodeDefenseLineX):
	* rcsc/player/debug_client.cpp (addMessage, addFreeform):
	* rcsc/player/logger.cpp (addText, addText):
	* rcsc/gz/gzfstream.cpp (makeModeString):
	- replaced sprintf/vsprintf with snprintf/vsnprintf.

2006-09-28  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/audio_sensor.h:
	* rcsc/player/audio_sensor.cpp:
	- implemented a freeform message parser.
	- need to implement a clang parser.

	* rcsc/coach/coach_agent.h:
	* rcsc/coach/coach_agent.cpp:
	* rcsc/coach/global_world_model.h:
	* rcsc/coach/global_world_model.cpp:
	- implemented an interface to send a freeform message.
	- implemented a very simple freeform message manager.

2006-09-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- prepared new release version, 1.1.0
	- added librcsc.spec as target

	* librcsc.spec.in:
	- added spec fila to make a RPM package.

	* rcsc/rcg/parser.cpp:
	- removed unused file.

	* Makefile.am:
	- added 'make doc' option to generate the Doxygen documents.
	- Now, 'doc' directory is removed by 'make distclean'.

	* Doxyfile.in:
	- added autoconf variables to generate a package name, a version
	number etc.

	* rcsc/coach/cycle_data.h:
	* rcsc/coach/cycle_data.cpp:
	- added offside line calculation method.

2006-09-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/coach/cycle_data.h:
	* rcsc/coach/cycle_data.cpp:
	* rcsc/coach/global_world_model.h:
	* rcsc/coach/global_world_model.cpp:
	- added new member method, getBallStatus() to check the ball
	position status.

	* rcsc/param/server_param.h:
	- changed default parameters' accessibility to public.

	* rcsc/types.h:
	- added new enum BallStatus. this type is almost the same as
	BallPosInfo in rcssserver/types.h
	- added BALL_STATUS_STRINGS. this is same as BALL_POS_INFO_STRINGS
	in rcssserver/types.h

	* rcsc/util/game_mode.h:
	* rcsc/util/game_mode.cpp:
	- moved MapHolder declaration to the source file.
	- changed MapHolder implementation policy.

2006-09-25  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/coach/global_world_model.h:
	* rcsc/coach/global_world_model.cpp:
	* rcsc/coach/coach_agent.h:
	* rcsc/coach/coach_agent.cpp:
	* rcsc/coach/trainer_agent.h:
	* rcsc/coach/trainer_agent.cpp:
	- moved parsing methods from WorldModel to CoachAgent/TrainerAgent.
	- changed some data structure and its interface.

	* rcsc/player/audio_sensor.cpp (parseTrainer):
	- changed string clean algorithm.

2006-09-19  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/coach/cycle_data.h:
	* rcsc/coach/cycle_data.cpp:
	* rcsc/coach/global_visual_sensor.h:
	* rcsc/coach/global_visual_sensor.cpp:
	* rcsc/coach/global_world_model.h:
	* rcsc/coach/global_world_model.cpp:
	- started to implement new coach/trainer world model.

	* rcsc/coach/cycle_info.h:
	* rcsc/coach/cycle_info.cpp:
	- renamed to cycle_data.{h,cpp}
	- renamed class.

	* rcsc/game_mode.h:
	- added time() to refere the update time.

	* rcsc/rcg/parser_v3.cpp:
	- changed error handling method. removed throw statement.

	* rcsc/rcg/factory.h:
	* rcsc/rcg/parser.h:
	* rcsc/rcg/parser.cpp:
	- removed ParserHolder class.
	- moved typedef of ParserPtr to parser.h

2006-09-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/net/udp_socket.cpp:
	- reimplemented using getaddrinfo(). still need some changes to
	clean up the code.
	- removed inet_aton().

2006-09-17  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcsc.h:
	* rcsc/action.h:
	* rcsc/coach.h:
	* rcsc/geom.h:
	* rcsc/net.h:
	* rcsc/param.h:
	* rcsc/player.h:
	* rcsc/trainer.h:
	- added covinience header files.

	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	- some modules are moved to PlayerAgentImpl to hide them from
	user.

	* rcsc/player/audio_sensor.h:
	* rcsc/player/audio_sensor.h:
	- started to reimplement communication modules.
	- added new struct types to hold a communication message info.
	- added trainer message parser.

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	* rcsc/param/cmd_line_parser.ch:
	* rcsc/param/cmd_line_parser.cpp:
	- changed the policy of a short name command line option. Now we
	can use more convinient style option name. (e.g. -gth )

2006-09-13  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/audio_sensor.h:
	* rcsc/player/audio_sensor.cpp:
	* rcsc/player/player_agent.cpp:
	- added trainer message parser. but just hold raw trainer message
	body.

	* rcsc/util/game_mode.h:
	* rcsc/util/game_mode.cpp (update):
	- To support old trainer audio message, changed return type of
	GameMode::update() to boolean. Agent programs should check the
	retuned value of this method.

2006-09-12  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	* rcsc/player/coach_agent.h:
	* rcsc/player/coach_agent.cpp:
	* rcsc/player/trainer_agent.h:
	* rcsc/player/trainer_agent.cpp:
	- changed command line argument parsing policy.
	- removed usage().

	* rcsc/player/player_config.h:
	* rcsc/player/player_config.cpp:
	- removed ParamMap member variable.
	- changed parameter map handling policy.
	- removed printHelp() and printValues().

	* rcsc/player/player_agent.cpp (analyzeHear):
	- fixed hear message sender analysis.

2006-09-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/param_map.cpp (printHelp):
	- reimplemented help description output format.

	* rcsc/param/param_map.h:
	- renamed getLongName(), getShortName() and getDescription() to
	longName(), shortName(), description().

2006-09-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/matrix_2d.h:
	- changed 'void transform(Vector2D&)' to 'void
	transform(Vector2D*)' to avoid the ambiguousness.

2006-09-05  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/matrix_2d.h:
	* rcsc/geom/matrix_2d.cpp:
	- added Matrix2D class that can calculate linear transformation.

2006-08-31  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/vector_2d.h:
	- removed resize() and resizedVector()
	- added setLengthVector()

	* rcsc/geom/delaunay_triangulation.cpp (removeInitialVertices):
	- fixed bug when we use gcc-4.1 on Gentoo. but I could not find
	the reason of this problem...

2006-08-30  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/delaunay_triangulation.h:
	* rcsc/geom/delaunay_triangulation.cpp:
	- moved from soccerwindow2.
	- renamed class.
	- added Doxygen comments.
	- cleaned up the code.

2006-08-29  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/trainer/trainer_agent.cpp (analyzeCycle, analyzeHear):
	- fixed player's hear message parser. More strict parser will be
	needed.

	* rcsc/math_util.h:
	- added bound() that is same as min_max().

2006-08-24  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/trainer/trainer_agent.cpp:
	- fixed hear message analysis.
	- added missing configuration check for eye and ear mode.

2006-08-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/debug_client.cpp:
	- reimplemented PlayerPrinter.
	- removed UnknownPlayerPrinter and integrated to PlayerPrinter..

	* rcsc/player/player_object.h:
	* rcsc/player/player_object.cpp:
	- added isKickable().
	[TODO]PlayerType parameter should be considered.

	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- cleaned up the updateObjectRelation() implementation;
	added updatePlayerMatrix()
	- started to reimplement.player update algorithm.

2006-08-10  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/ball_object.h:
	* rcsc/player/ball_object.cpp:
	* rcsc/player/self_object.h:
	* rcsc/player/self_object.cpp:
	* rcsc/player/stamina_model.h:
	* rcsc/player/stamina_model.cpp:
	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- supported fullstate.

	* rcsc/player/fullstate_sensor.h:
	- moved internal classes BallT and PlayerT to out of class,
	and renamed to FullstateBallT and FullstatePlayerT.

	* configure.ac:
	- removed AC_PROG_RANLIB.

2006-08-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/player/fullstate_sensor.h:
	- renamame class FullStateSensor to FullstateSensor.

	* rcsc/player/player_config.h:
	* rcsc/player/player_config.cpp:
	* rcsc/player/player_agent.h:
	* rcsc/player/player_agent.cpp:
	- setDebugFlags() is removed from PlayerConfig, and its
	implementation is moved to PlayerAgent.

	* rcsc/player/world_model.h:
	* rcsc/player/world_model.cpp:
	- renamed getTeamName() to teamName(),
	getOurSide() to ourSide(),
	getTime() to time(),
	getSeeUpdateTime() to seeTime(),
	getLastSetPlayStartTime() to lastSetPlayStartTime(),
	getGameMode() to gameMode(),
	getTeammatesFromSelf() to teammatesFromSelf(),
	getTeammatesFromBall() to teammatesFromBall(),
	getOpponentsFromSelf() to opponentsFromSelf(),
	getOpponentsFromBall() to opponentsFromBall(),
	getOffsideLineX() to offsideLineX()
	and getDefenseLineX() to defenseLineX().
	to keep compatibility, old name version remains.
	- renamed updatePlayMode() to updateGameMode()
	- removed unnecessary arguments from update related methods.
	- started to implement updateFullstate()

	* src/scheduler.cpp (TeamNameLoader):
	- fixed problem of team name loading. In the previous implement,
	TeamNameLoader cannot handle input without last new line.
	- added check of character validity.

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	- Now, the duplicated parameter name is checked in add().
	- added remove() method.
	- added struct BoolSwitch to handle a switch type parameter.
	- removed enum ParamType.
	- removed the type specified ParamMap::Registrar::operator().
	- added getParamPtrShortName()

2006-08-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/cmd_line_parser.h:
	- added verbose mode.

	* rcsc/player/soccer_action.h:
	- addec pure virtual method, clone(), to NeckAction, ViewAction
	and ArmAction. This method creates the cloned action object.

2006-07-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/trainer/trainer_agent.h:
	* rcsc/trainer/trainer_agent.cpp:
	- temporary added new methods, getTime(), getGameMode(),
	getVisual() and	doMovePlayer().
	- removed definition of doAction() and this became pure	virtual
	method.

2006-07-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/action/*:
	* rcsc/coach/*:
	* rcsc/player/*:
	* rcsc/trainer/*:
	- moved from helios.

	* configure.ac:
	- fixed for new library structure.

2006-06-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/player_type.h:
	- added getDashPowerToKeepSpeed(). we can estimate the required
	dash power to keep the desired speed.

2006-06-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/segment_2d.h:
	- fixed serious bug in Segment2D::contains().

2006-05-29  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/rect_2d.h:
	- added center().

2006-05-19  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* src/Makefile.am:
	* src/rcg2txt.cpp:
	- added new tool 'rcg2txt'

2006-05-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/bpn1.h:
	- changed M_hidlen_layer variable to mutable.
	- changed propaget() to const method.

2006-05-17  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/circle_2d.cpp (intersection):
	- fixed defect about null pointer reference possibility.

2006-05-02  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/net/udp_socket.cpp (receive):
	- fixed type of 6th argument of recvfrom to socklen_t.

	* configure.ac:
	- added AC_CHECK_TYPES(socklen_t,...

2006-02-03  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/cmd_line_parser.cpp:
	* rcsc/param/conf_file_parser.cpp:
	* rcsc/param/rcss_param_parser.cpp:
	- reimplemented each parse() using ParamMap::getParamPtr()

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	- added ParamMap::getParamPtr() to access to the parameter entry.

2006-01-30  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/vector_2d.h:
	- added setPolar() as a replacement of polar type assign()

2006-01-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/line_2d.h:
	- added ERROR_VAL static variable.
	- changed returned value of getX() and getY() when line is
	vertical or horizontal.

2006-01-25  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/Makefile.am:
	* rcsc/geom/Makefile.am:
	* rcsc/gz/Makefile.am:
	* rcsc/monitor/Makefile.am:
	* rcsc/net/Makefile.am:
	* rcsc/param/Makefile.am:
	* rcsc/rcg/Makefile.am:
	* rcsc/util/Makefile.am:
	- all sub libraries are integrated to librcsc.la
	- all sub libraries are changed to noinst_ type.

2006-01-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/rcss_param_parser.h:
	* rcsc/param/rcss_param_parser.cpp:
	- reimplemented
	- added strict lexer.

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	- allowed ParamEntry::analyze() to accept empty string.
	- added ParamEntry::isSwitch() to check the parameter type.
	- renamed print() to  printHelp().
	- added printValues().

2006-01-13  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/vector_2d.h:
	- added length(), setLength() dir() and setDir() as an alias.
	- added missing return statement.

	* rcsc/geom/segment_2d.h:
	- added helper predicate inRect() to check if the point is
	within the rectangle defined by segment as a diagonal line.

	* rcsc/geom/ray_2d.h:
	* rcsc/geom/ray_2d.cpp:
	* rcsc/geom/segment_2d.h:
	* rcsc/geom/segment_2d.cpp:
	- added predicate method to check & get the intersection with
	line.

2006-01-12  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/segment_2d.h:
	* rcsc/geom/segment_2d.cpp:
	- added new class Segment2D to handle line segment object.

2006-01-11  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/circle_2d.h:
	* rcsc/geom/circle_2d.cpp:
	- added static utility circumcircle(a,b,c) that returns
	circumcircle calculated from triangle vertex.

	* rcsc/geom/triangle_2d.h:
	* rcsc/geom/triangle_2d.cpp:
	- all triangle centers method are replaced by static method.

	* rcsc/geom/line_2d.h:
	* rcsc/geom/line_2d.cpp:
	- added static utility perpendicular_bisector(p1,p2) that returns
	perpendicular bisector line(Suichoku Nitoubunsen) from two point.
	- added static utility angle_bisector(origin,a1,a2) that returns
	angle bisector line.

2006-01-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/net/udp_socket.h:
	- added isOpen() method.

2006-01-07  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/player_type.cpp (createDummyType):
	- dummy type bacomes the fastest player type

	* rcsc/param/rcss_param_parser.h:
	* rcsc/param/rcss_param_parser.cpp:
	- tested to handle quated string.

2006-01-06  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/game_mode.h:
	* rcsc/util/game_mode.cpp:
	- added playmode wrapper class

2006-01-04  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/types.h:
	- renamed Line_Max to Line_Unknown

2006-01-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/cmd_line_parser.h:
	* rcsc/param/cmd_line_parser.cpp:
	- added support of ignored parameter name.

2005-12-31  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/monitor/monitor_command.h:
	* rcsc/monitor/monitor_command.cpp:
	* rcsc/monitor/Makefile.am:
	- added new directory.
	- monitor related files were moved from rcsc/
	- some inline codes werer moved to source file.

	* rcsc/util/soccer_math.cpp:
	- renamed from smath.cpp

	* rcsc/soccer_math.h:
	- moved from rcsc/util/ and renamed from smath.h

	* rcsc/bpn1.h:
	- moved from rcsc/util/

	* rcsc/util/Makefile.am:
	- The directry for header files and source files are separated.

2005-12-30  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/timer.h:
	* rcsc/util/timer.cpp:
	- integrated from time_stamp.* and msec_timer.*

	* rcsc/util/msec_timer.h:
	* rcsc/util/msec_timer.cpp:
	* rcsc/util/time_stamp.h:
	* rcsc/util/time_stamp.cpp:
	- removed

	* rcsc/types.h:
	- all command types are removed to each abstarct command class.

2005-12-28  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/monitor_command.h:
	- moved from helios

2005-12-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/types.h:
	- added enum PlayerCommandType
	- added enum TrainerCommandType
	- added enum CoachCommandType
	- added enum MonitorCommandType

	* rcsc/random.h:
	* rcsc/util/random.h:
	- moved from util to parent directory.

	* rcsc/param/player_param.cpp:
	* rcsc/param/player_type.h:
	* rcsc/param/player_type.cpp:
	* rcsc/param/server_param.h:
	* rcsc/param/server_param.cpp:
	* rcsc/util/smath.h:
	- removed unnecessary rcsc::

	* configure.ac:
	- added check of boost/random.hpp and boost/lexical_cast.hpp
	- added check of floor and gettimeofday to AC_CHECK_FUNCS
	- added AC_CHEADER_TIME
	- added check of sys/time.h by AC_CHECK_HEADERS.

	* rcsc/util/Makefile.am:
	- added time_stamp.{h,cpp} and msec_timer.{h,cpp}

	* rcsc/util/time_stamp.h:
	* rcsc/util/time_stamp.cpp:
	- moved from helios

	* rcsc/util/msec_timer.h:
	* rcsc/util/msec_timer.cpp:
	- moved from helios and renamded from stop_watch.*.

2005-12-26  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/util/bpn1.h:
	- moved from helios and soccerwindow2.

	* rcsc/util/random.h:
	- moved from helios' library.

2005-12-20  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/player_param.cpp:
	- added missing include <cmath> to fix gcc-3.4 compilatin
	problem.

2005-12-16  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- added test_param to EXAMPLE

	* example/param_main.cpp:
	- added as param module tester.

	* rcsc/param/player_param.h:
	* rcsc/param/player_param.cpp:
	* rcsc/param/player_type.h:
	* rcsc/param/player_type.cpp:
	* rcsc/param/server_param.h:
	* rcsc/param/server_param.cpp:
	- ported from helios' library

2005-12-15  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/param_parser.h:
	* rcsc/param/cmd_line_parser.h:
	* rcsc/param/cmd_line_parser.cpp:
	* rcsc/param/conf_file_parser.h:
	* rcsc/param/conf_file_parser.cpp:
	* rcsc/param/rcss_param_parser.h:
	* rcsc/param/rcss_param_parser.cpp:
	- ported from helios' library
	- reimplemented.

2005-12-14  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/param/param_map.h:
	* rcsc/param/param_map.cpp:
	- started to reimplement parameter parsing module
	- implemented boost::program_options like interface.

2005-12-10  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* example/Makefile.am:
	- added variable EXAMPLE to change the build target

	* configure.ac:
	- added gethostbyname, memset and socket to AC_CHECK_FUNCS.
	- added AC_CHECK_HEADER for arpa/inet.h, fcntl.h, netinet/in.h,
	netdb.h, sys/socket.h and unistd.h.
	- added variable EXAMPLE to change the build target

	* rcsc/net/Makefile.am:
	* rcsc/net/udp_socket.h:
	* rcsc/net/udp_socket.cpp:
	- added network library.
	- UDPSocket was moved from helios and soccerwindow2 and almost all
	implementations were separated to .cpp source file to keep
	portability.

2005-12-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/types.h:
	- renamed elements of enum SideID.
	- enum PlayMode was moved from rcsc/rcg/types.h
	- const int MAX_PLAYER was moved from rcsc/rcg/types.h

	* rcsc/rcg/types.h:
	- removed enum Side
	- removed enum PlayMode
	- removed const int MAX_PLAYER

	* rcsc/geom/vector_2d.h:
	- fixed Doxygen comments.
	- member method scale() was renamed to resize().
	- member method scaleVector() was renamed to resizedVector().

2005-12-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/types.h:
	- moved from helios/rcsc/soccer/soccer_types.h

	* rcsc/geom/triangle_2d.cpp (getInnerCenter):
	- AngleDeg's memeber bisect() is replaced by AngleDeg's static
	bisect() method.

	* rcsc/util/smath.h:
	* rcsc/util/smath.cpp:
	- calc_sin_min_max() and calc_cos_min_max() were moved to AngleDeg
	as a member method.

	* rcsc/geom/angle_deg.h:
	* rcsc/geom/angle_deg.cpp:
	- implemented sinMinMax() and cosMinMax()
	- removed member method bisect()

2005-12-07  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/vector_2d.h:
	- added new method scale() and scaledVector() to adjust vector
	length.
	- normalize(double) was replaced by scale(double) and
	normalize() became pure normalization method.
	- renamed normalizedVector() to norm()

	* rcsc/math_util.h:
	- added missing include <algorithm>

2005-12-02  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/util/smath.h:
	* rcsc/util/smath.cpp:
	- added calc_sin_min_max & calc_cos_min_max

	* rcsc/math_util.h (calc_first_term_geom_series_last):
	- added generic geometric series utilities

2005-12-01  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/math_util.h:
	- ported from helios' math_utils

	* rcsc/util/smath.h:
	* rcsc/util/smath.cpp:
	- ported from helios' soccer_math
	(calc_first_term_geom_series):
	- changed argument order.

	* rcsc/util/Makefile.am:
	- added new sub library librcsc_util

	* configure.ac:
	- AM_CONFIG_HEADER was replaced by AC_CONFIG_HEADERS,
	because AM_CONFIG_HEADER becomes an obsolete macro.

2005-11-29  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/game_time.h:
	- ported from helios.

2005-11-25  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/circle_2d.h:
	- changed argument of intersection method to pointer.

	* rcsc/geom/size_2d.h:
	- added new class Size2D.

2005-11-22  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/Makefile.am:
	* rcsc/geom/triangle_2d.h:
	* rcsc/geom/triangle_2d.cpp:
	- added triangle_2d.{h,cpp}

2005-11-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/Makefile.am:
	- increment library version

	* rcsc/geom/line_2d.h:
	* rcsc/geom/line_2d.cpp:
	- ported from helios library.

2005-06-25  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* src/resultprinter.cpp (main):
	- supported multiple argument as an input file name.

2005-06-23  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/Makefile.am:
	- incremented LT_CURRENT

	* src/resultprinter.cpp:
	* src/scheduler.cpp:
	- added as installed programs for rcleagueman(RoboCup League
	Manager).

	* rcsc/rcg/factory.h:
	* rcsc/rcg/factory.cpp:
	- added parser factory utility as an global function.

2005-06-10  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/Makefile.am:
	* rcsc/gz.h:
	* rcsc/rcg.h:
	- module header files are moved to top include directory.

	* rcsc/rcg/repository.h:
	* rcsc/rcg/repository.cpp:
	* rcsc/rcg/holder.h:
	* rcsc/rcg/holder.cpp:
	- renamed class name and file name.

	* rcsc/rcg/Makefile.am:
	* rcsc/rcg/factory.h:
	* rcsc/rcg/factory.cpp:
	- added a parser factory global function.

2005-05-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- updated minor version.

	* rcsc/rcg/parser_v1.cpp:
	* rcsc/rcg/parser_v2.cpp:
	* rcsc/rcg/parser_v3.cpp:
	- removed pre-linked parser holder.

2005-02-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/geom/Makefile.am:
	* rcsc/geom/angle_deg.h:
	* rcsc/geom/angle_deg.cpp:
	* rcsc/geom/vector2d.h:
	* rcsc/geom/vector2d.cpp:
	- added new geometry library module

2004-11-27  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/rcg/types.h:
	- renamed enum 'SideType' to 'Side'
	- added enum PlayMode

2004-11-24  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcsc/gz/Makefile.am:
	* rcsc/rcg/Makefile.am:
	- added new install header files.

	* rcsc/gz/gz.h:
	* rcsc/rcg/rcg.h:
	- added.

	* rctools/:
	* rcsc/:
	- renamed project name from rctools to librcsc.
	- renamed install directory name from rctools to rcsc.
	- renamed all related things.

2004-11-18  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* configure.ac:
	- AC_CONFIG_HEADER macro is changed to AM_CONFIG_HEADER

2004-11-09  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rctools/gz/gzfstream.h:
	* rctools/gz/gzfilterstream.h:
	* rctools/rcg/handler.h:
	* rctools/rcg/loader.h:
	* rctools/rcg/parser.h:
	* rctools/rcg/parser_v1.h:
	* rctools/rcg/parser_v2.h:
	* rctools/rcg/parser_v3.h:
	* rctools/rcg/repository.h:
	* rctools/rcg/util.h:
	- fixed include gurard name.

	* rcg/parser_v1.cpp:
	* rcg/parser_v2.cpp:
	* rcg/parser_v3.h:
	* rcg/parser_v3.cpp:
	* rcg/handler.h:
	* rcg/loader.h:
	- remoded streampos argument from all member methods.

	* gz/gzfstream.h:
	- added M_remained_size and M_remained_char.

	* gz/gzfstream.cpp (seekoff):
	- fixed defect for tellg which calls seekoff(0).
	(underflow):
	- s_remained_size and s_remained_char is changed to member
	variable.

	* rcg/parser_v1.h:
	* rcg/parser_v2.h:
	* rcg/parser_v3.h:
	- replaced version number value to the const variables defined in
	types.h.

	* rcg/parser_v2.cpp (parseData):
	* rcg/parser_v3.cpp (parseData):
	* rcg/repository.cpp (addDispInfo):
	(addDispInfo2):
	- fixed incorrect byte order function. htons -> ntohs

	* rcg/loader.h:
	- fixed missing return statement.

	* test/loader_main.cpp:
	- added to test

	* rcg/handler.h:
	* rcg/loader.h:
	- fixed incorrect default constructor operation.

	* configure.ac:
	- changed the check of boost/shared_ptr.hpp to
	boost/scoped_ptr.hpp

2004-11-08  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* gz/gzfilterstream.h:
	* gz/gzfilterstream.cpp:
	- added, but not fully implemented or tested.

	* rcg/Makefile.am:
	- renamed librcg.la to librctools_rcg.la

	* gz/Makefile.am:
	- renamed libgzstream.la to librctools_gz.la

	* rcg/util.h:
	* rcg/types.h:
	* rcg/repository.cpp:
	* rcg/repository.h:
	* rcg/parser_v3.cpp:
	* rcg/parser_v3.h:
	* rcg/parser_v2.cpp:
	* rcg/parser_v2.h:
	* rcg/parser_v1.cpp:
	* rcg/parser_v1.h:
	* rcg/parser.cpp:
	* rcg/parser.h:
	* rcg/loader.h:
	* rcg/handler.h:
	* gz/gzfstream.h:
	* gz/gzfstream.cpp:
	- included in namespace 'rct'.

2004-11-05  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* rcg/:
	* librcg/:
	- 'librcg' directory is renamed to 'rcg'

	* librcg/Makefile.am:
	- changed header files install directory to include/rctools/librcg.

	* gz/gzfstream.h:
	* gz/gzfstream.cpp:
	* gz/gzfilterstream.h:
	* gz/gzfilterstream.cpp:
	- added. but not fully implemented yet.

2004-11-04  Hidehisa Akiyama  <akky@users.sourceforge.jp>

	* librcg/:
	* src/:
	- 'src' directory is renamed to 'librcg'

	* src/loader.h:
	- removed M_log_version.

	* src/handler.h:
	- added M_log_version.
	- all pure virtual methods are changed to normal virtual method.

	* src/parser.h:
	* src/parser.cpp:
	* src/parser_v1.h:
	* src/parser_v1.cpp:
	* src/parser_v1.h:
	* src/parser_v1.cpp:
	* src/parser_v1.h:
	* src/parser_v1.cpp:
	- totally restructured to create parsers statically.

	* configure.ac:
	- started to support GNU Autotools
